---
updatedAt: 2026-08-14T15:55:52.000Z
agentTools:
  projectIndex: https://developers.bluesnap.com/v8976-JSON/llms.txt
---

# Create Merchant-Managed Subscription

If you manage your own subscriptions, the Create Merchant-Managed Subscription request lets you set up a merchant-managed subscription, which associates an initial subscription charge with all recurring charges.

To process recurring subscription charges, you'll send a [Create Merchant-Managed Subscription Charge](https://developers.bluesnap.com/reference/create-merchant-managed-subscription-charge) request.

For more information on working with merchant-managed subscriptions, refer to [Merchant-Managed Subscriptions](https://developers.bluesnap.com/reference/subscription-management#section-merchant-managed-subscriptions).

<Callout icon="👍" theme="okay">
  **Reporting Benefits**

  With merchant-managed subscriptions, you get access to our advanced reporting capabilities that provide a clear differentiation between one-time and recurring charges, and our conversion reports that take into account your specific dunning logic.
</Callout>

***

<Callout icon="📘" theme="info">
  **Send a test request**

  Go to [API Explorer](#api-explorer) to send a test request to our sandbox environment and receive a response in real time.
</Callout>

### Request Content

Send a **[charge](https://developers.bluesnap.com/reference/charge)** object, with the following:

| Property                 | Type      | Required                                                                                                                                             |
| :----------------------- | :-------- | :--------------------------------------------------------------------------------------------------------------------------------------------------- |
| `amount`                 | *decimal* | <span style={{color: "#F37500"}}>**required**</span> for ACH/ECP and SEPA Direct Debit; otherwise optional                                           |
| `authorizedByShopper`    | *boolean* | <span style={{color: "#F37500"}}>**required**</span> for ACH/ECP and SEPA Direct Debit (value must be **true**)                                      |
| `currency`               | *string*  | <span style={{color: "#F37500"}}>**required**</span>                                                                                                 |
| `descriptorPhoneNumber`  | *string*  | optional                                                                                                                                             |
| `level3Data`             | *object*  | optional (refer to [level3Data](https://developers.bluesnap.com/reference/level3data))                                                                                                     |
| `merchantTransactionId`  | *string*  | optional                                                                                                                                             |
| `networkTransactionInfo` | *object*  | optional (refer to [networkTransactionInfo](https://developers.bluesnap.com/reference/network-transaction-info))                                                                           |
| `payerInfo`              | *object*  | optional - do not include if sending `vaultedShopperId` (refer to [payerInfo](https://developers.bluesnap.com/reference/payer-info))                                                       |
| `paymentSource`          | *object*  | <span style={{color: "#F37500"}}>**required** for `payerInfo`</span>; optional for `vaultedShopperId` (refer to [paymentSource](https://developers.bluesnap.com/reference/payment-source)) |
| `shippingContactInfo`    | *object*  | optional (refer to [shippingContactInfo](https://developers.bluesnap.com/reference/shipping-contact-info))                                                                                 |
| `softDescriptor`         | *string*  | optional                                                                                                                                             |
| `taxReference`           | *string*  | optional                                                                                                                                             |
| `threeDSecure`           | *object*  | optional (refer to [threeDSecure](https://developers.bluesnap.com/reference/threedsecure))                                                                                                 |
| `transactionFraudInfo`   | *object*  | optional (refer to [transactionFraudInfo](https://developers.bluesnap.com/reference/transaction-fraud-info))                                                                               |
| `scheduled`              | *boolean* | optional                                                                                                                                             |
| `transactionInitiator`   | *string*  | optional                                                                                                                                             |
| `transactionMetaData`    | *object*  | optional (refer to [transactionMetaData](https://developers.bluesnap.com/reference/transaction-meta-data))                                                                                 |
| `vaultedShopperId`       | *integer* | optional - do not include if sending `payerInfo`                                                                                                     |
| `vendorsInfo`            | *object*  | optional (refer to [vendorsInfo](https://developers.bluesnap.com/v8976-JSON/reference/vendorsinfo))                                                  |

### Response Details

If successful, the response HTTP status code is 200 OK.<br />The response body contains the [charge](https://developers.bluesnap.com/reference/charge) resource.<br />The `subscriptionId` appears in the response body (unless payment source was ACH/ECP or SEPA Direct Debit).

## Examples

### Request Examples

```curl Create Merchant-Managed Subscription request: with credit card
curl -v -X POST https://sandbox.bluesnap.com/services/2/recurring/ondemand \
-H 'Content-Type: application/json' \
-H 'Authorization: Basic dXNlcm5hbWU6cGFzc3dvcmQ=' \
-d '
{
  "amount": 45,
  "currency": "USD",
  "merchantTransactionId": "MyUniqueOnDemandSubscription",
  "taxReference": "048deff0-a285-47e1-bc39-42f79bf0095b",
  "payerInfo": {
    "firstName": "John",
    "lastName": "Doe",
    "zip": "02453",
    "country": "us"
  },
  "paymentSource": {
    "creditCardInfo": {
      "creditCard": {
        "expirationYear": 2023,
        "securityCode": 111,
        "expirationMonth": "05",
        "cardNumber": 4012000033330026
      }
    }
  }
}
```
```curl with Apple Pay
curl -v -X POST https://sandbox.bluesnap.com/services/2/recurring/ondemand \
-H 'Content-Type: application/json' \
-H 'Authorization: Basic dXNlcm5hbWU6cGFzc3dvcmQ=' \
-d '
{
	"amount": 45, 
    "currency": "USD",
	"paymentSource": {
		"wallet": {
			"walletType": "APPLE_PAY",
			"encodedPaymentToken": "eyJiaWxsaW5nQ29udGFjdCI6eyJhZGRyZ..."
		}
	}
}
```
```curl with SEPA Direct Debit
curl -v -X POST https://sandbox.bluesnap.com/services/2/recurring/ondemand \
-H 'Content-Type: application/json' \
-H 'Authorization: Basic dXNlcm5hbWU6cGFzc3dvcmQ=' \
-d '
{
  "amount": 45,
  "currency": "EUR",
  "authorizedByShopper": true,
  "payerInfo": {
    "firstName": "John",
    "lastName": "Doe",
    "country": "nl",
    "address": "addressLine1", 
    "address2": "addressLine2",  
    "city": "myCity",
    "zip": "12345"
  },
  "paymentSource": {
    "sepaDirectDebitInfo": {
      "sepaDirectDebit": {
        "iban": "GB33BUKB20201555555555",
        "bic": "PBNKDEFFXXX"
      }
    }
  }
}
```
```curl with ACH/ECP
curl -v -X POST https://sandbox.bluesnap.com/services/2/recurring/ondemand \
-H 'Content-Type: application/json' \
-H 'Authorization: Basic dXNlcm5hbWU6cGFzc3dvcmQ=' \
-d '
{
  "amount": 65,
  "currency": "USD",
  "authorizedByShopper": true,
  "payerInfo": {
    "firstName": "Jane",
    "lastName": "Doe",
    "zip": "02453",
    "country": "us"
  },
  "paymentSource": {
    "ecpInfo": {
      "ecp": {
        "accountNumber": 4099999992, 
        "routingNumber": "011075150",
        "accountType": "CONSUMER_CHECKING"
      }
     }
   }
}
```
```curl with Google Pay
curl -v -X POST https://sandbox.bluesnap.com/services/2/recurring/ondemand \
-H 'Content-Type: application/json' \
-H 'Authorization: Basic dXNlcm5hbWU6cGFzc3dvcmQ=' \
-d '
{
  "amount": 45, 
  "currency": "USD", 
  "paymentSource": {
    "wallet": {
      "walletType": "GOOGLE_PAY",
      "encodedPaymentToken": "eyJ0b2tliZ2l2ZW5OYW1lIjoiTG9kIiwiY291bnRye…"
    }
  }      
}
```
```curl New shopper with different billing
curl -v -X POST https://sandbox.bluesnap.com/services/2/recurring/ondemand \
-H 'Content-Type: application/json' \
-H 'Authorization: Basic dXNlcm5hbWU6cGFzc3dvcmQ=' \
-d '
{  
   "payerInfo":{  
      "firstName":"PIFirstName",
      "lastName":"PILastName",
      "zip":"PIZip",
      "email":"tt@gmail.com",
      "country":"il",
      "address":"PIaddress1",
      "address2":"PIaddress2",
      "city":"PICity"
   },
   "paymentSource":{  
      "creditCardInfo":{  
         "creditCard":{  
            "cardNumber":"5555555555554444",
            "securityCode":"111",
            "cardType":"MASTERCARD",
            "expirationMonth":"07",
            "expirationYear":"2025"
         },
         "billingContactInfo":{  
            "firstName":"BiFirstName",
            "lastName":"BiLastName",
            "address1":"BiAddress1",
            "address2":"BiAddress2",
            "city":"BiCity",
            "state":"CA",
            "country":"us",
            "zip":"BiZip"
         }
      }
   },
   "amount":"10",
   "currency":"USD"
}
```
```curl Vaulted shopper with billing
curl -v -X POST https://sandbox.bluesnap.com/services/2/recurring/ondemand \
-H 'Content-Type: application/json' \
-H 'Authorization: Basic dXNlcm5hbWU6cGFzc3dvcmQ=' \
-d '
{  
   "vaultedShopperId":19641554,
   "paymentSource":{  
      "creditCardInfo":{  
         "creditCard":{  
            "cardNumber":"5555555555554444",
            "securityCode":"111",
            "cardType":"MASTERCARD",
            "expirationMonth":"07",
            "expirationYear":"2025"
         },
         "billingContactInfo":{  
            "firstName":"BiFirstName",
            "lastName":"BiLastName",
            "address1":"BiAddress1",
            "address2":"BiAddress2",
            "city":"BiCity",
            "state":"CA",
            "country":"us",
            "zip":"BiZip"
         }
      }
   },
   "amount":"10",
   "currency":"USD"
}
```
```curl New shopper with hosted fields and different billing
curl -v -X POST https://sandbox.bluesnap.com/services/2/recurring/ondemand \
-H 'Content-Type: application/json' \
-H 'Authorization: Basic dXNlcm5hbWU6cGFzc3dvcmQ=' \
-d '
{  
   "payerInfo":{  
      "firstName":"PIFirstName",
      "lastName":"PILastName",
      "zip":"PIZip",
      "email":"tt@gmail.com",
      "country":"il",
      "address":"PIaddress1",
      "address2":"PIaddress2",
      "city":"PICity"
   },
   "paymentSource":{  
      "creditCardInfo":{  
         "pfToken":"77fdabea752d7a23c763d3690111ffea9d173b34eaa4e8e37d7c59360a167d4a_",
         "billingContactInfo":{  
            "firstName":"BiFirstName",
            "lastName":"BiLastName",
            "address1":"BiAddress1",
            "address2":"BiAddress2",
            "city":"BiCity",
            "state":"CA",
            "country":"us",
            "zip":"BiZip"
         }
      }
   },
   "amount":"10",
   "currency":"USD"
}
```
```curl Vaulted shopper with hosted fields and different billing
curl -v -X POST https://sandbox.bluesnap.com/services/2/recurring/ondemand \
-H 'Content-Type: application/json' \
-H 'Authorization: Basic dXNlcm5hbWU6cGFzc3dvcmQ=' \
-d '
{  
   "vaultedShopperId":19641542,
   "paymentSource":{  
      "creditCardInfo":{  
         "pfToken":"2f1fee480db183617a5e79b340fb2b20954331d6c96b4889a846f95546ef8fc1_",
         "billingContactInfo":{  
            "firstName":"BiFirstName",
            "lastName":"BiLastName",
            "address1":"BiAddress1",
            "address2":"BiAddress2",
            "city":"BiCity",
            "state":"CA",
            "country":"us",
            "zip":"BiZip"
         }
      }
   },
   "amount":"10",
   "currency":"USD"
}
```
```curl with vendors info
curl -v -X POST https://sandbox.bluesnap.com/services/2/recurring/ondemand \
-H 'Content-Type: application/json' \
-H 'Authorization: Basic dXNlcm5hbWU6cGFzc3dvcmQ=' \
-d '
{
  "amount": 45,
  "currency": "USD",
  "merchantTransactionId": "MyUniqueOnDemandSubscription",
  "payerInfo": {
    "firstName": "John",
    "lastName": "Doe",
    "zip": "02453",
    "country": "us"
  },
  "paymentSource": {
    "creditCardInfo": {
      "creditCard": {
        "expirationYear": 2023,
        "securityCode": 111,
        "expirationMonth": "05",
        "cardNumber": 4012000033330026
      }
    }
  },
  "vendorsInfo": {
    "vendorInfo": [{ "vendorId": "10398032" }]
  }
}'
```
```curl with metadata
curl -v -X POST https://sandbox.bluesnap.com/services/2/recurring/ondemand \
-H 'Content-Type: application/json' \
-H 'Authorization: Basic dXNlcm5hbWU6cGFzc3dvcmQ=' \
-d '
{
  "amount": 100,
  "currency": "USD",
  "merchantTransactionId": "112222",
  "transactionMetaData": {
    "metaData": [
      {
        "metaValue": 20,
        "metaKey": "stateTaxAmount",
        "metaDescription": "State Tax Amount"
      },
      {
        "metaValue": 20,
        "metaKey": "cityTaxAmount",
        "metaDescription": "City Tax Amount"
      },
      {
        "metaValue": 10,
        "metaKey": "shippingAmount",
        "metaDescription": "Shipping Amount"
      }
    ]
  },
  "payerInfo": {
    "firstName": "John",
    "lastName": "Doe",
    "zip": "92614",
    "country": "us"
  },
  "paymentSource": {
    "creditCardInfo": {
      "creditCard": {
        "expirationYear": 2023,
        "securityCode": 111,
        "expirationMonth": "05",
        "cardNumber": 4111111111111111
      }
    }
  }
}'
```

### Response Examples

```json Create Merchant-Managed Subscription response: with credit card
{
   "chargeId": 14837941,
   "subscriptionId": 13823081,
   "vaultedShopperId": 23976843,
   "transactionId": "1020296963",
   "merchantTransactionId": "MyUniqueOnDemandSubscription",
   "taxReference": "048deff0-a285-47e1-bc39-42f79bf0095b",
   "transactionDate": "2019-03-14",
   "amount": 45,
   "currency": "USD",
   "softDescriptor": "BLS*Testing",
   "paymentSource": {
       "creditCardInfo": {
           "billingContactInfo": {
               "firstName": "John",
               "lastName": "Doe",
               "zip": "02453",
               "country": "us"
           },
           "creditCard": {
               "cardLastFourDigits": "0026",
               "cardType": "VISA",
               "cardSubType": "CREDIT",
               "cardCategory": "CLASSIC",
               "binCategory": "CONSUMER",
               "cardRegulated": "N",
               "issuingBank": "EXTRAS TEST - VISA",
               "expirationMonth": "05",
               "expirationYear": "2023",
               "issuingCountryCode": "ru"
           }
       }
   },
   "chargeInfo": {
       "chargeType": "INITIAL"
   },
   "processingInfo": {
      "processingStatus": "SUCCESS",
      "cvvResponseCode": "MA",
      "authorizationCode": "OK1510",
      "avsResponseCodeZip": "U",
      "avsResponseCodeAddress": "U",
      "avsResponseCodeName": "U",
      "networkTransactionId": 16029749259621,
      "transactionRegion": "US"
   },
   "fraudResultInfo": {
       "deviceDataCollector": "N"
   }
}
```
```json with Apple Pay
{
    "chargeId": 175047,
    "subscriptionId": 39555006,
    "vaultedShopperId": 19598228,
    "transactionId": "38599972",
    "transactionDate": "2021-09-16",
    "amount": 45.00,
    "currency": "USD",
    "softDescriptor": "BLS*CodeDiggers",
    "paymentSource": {
        "wallet": {
            "walletType": "APPLE_PAY",
            "billingContactInfo": {
                "firstName": "John",
                "lastName": "Smith",
                "address1": "800 South Street",
                "city": "Waltham",
                "state": "MA",
                "zip": "01822",
                "country": "us"
            },
            "applePay": {
                "cardLastFourDigits": "1471",
                "cardType": "MASTERCARD",
                "cardSubType": "DEBIT",
                "cardCategory": "ACQUIRER ONLY",
                "binCategory": "CONSUMER",
                "cardRegulated": "N",
                "issuingCountryCode": "us",
                "issuingBank": "MASTERCARD - MEMBER TEST FACILITY",
                "dpanLastFourDigits": "6937",
                "dpanExpirationMonth": "9",
                "dpanExpirationYear": "2022"
            },
            "tokenizedCard": {
                "dpanExpirationMonth": "9",
                "dpanExpirationYear": "2022",
                "dpanLastFourDigits": "6937",
                "cardLastFourDigits": "1471",
                "cardType": "MASTERCARD",
                "cardSubType": "DEBIT",
                "cardCategory": "ACQUIRER ONLY",
                "binCategory": "CONSUMER",
                "cardRegulated": "N",
                "issuingCountryCode": "us",
                "issuingBank": "MASTERCARD - MEMBER TEST FACILITY"
            }
        }
    },
    "chargeInfo": {
        "chargeType": "INITIAL"
    },
    "processingInfo": {
        "processingStatus": "SUCCESS",
        "cvvResponseCode": "MA",
        "authorizationCode": "OK1510",
        "avsResponseCodeZip": "U",
        "avsResponseCodeAddress": "U",
        "avsResponseCodeName": "U",
        "networkTransactionId": 16029749259621,
        "transactionRegion": "US"
    },
    "fraudResultInfo": {}
}
```
```json with SEPA Direct Debit
{
  "vaultedShopperId": 55227297,
  "transactionId": "1119285107",
  "transactionDate": "2026-08-13",
  "amount": 45.00,
  "currency": "EUR",
  "softDescriptor": "BLS*TEST Horns and Hoove",
  "paymentSource": {
    "sepaDirectDebitInfo": {
      "sepaDirectDebit": {
        "bic": "PBNKDEFFXXX",      
        "ibanFirstFour": "DE91",
        "ibanLastFour": "0020",
        "mandateId": "TES403197",
        "mandateDate": "13-Aug-26",
        "preNotificationText": "The amount of 45 EUR will be collected using SEPA Direct Debit with Mandate Blu153577 from your bank account IBAN DE09XXXXXX7893 in the next few days. Please ensure sufficient funds in your account.",
        "preNotificationTranslationRef": "https://sandbox.bluesnap.com:443/services/2/translations/sepa/prenotification?transactionid=1119285107"
      }
    }
  },
  "chargeInfo": {
    "chargeType": "INITIAL"
  },
  "processingInfo": {
    "processingStatus": "PENDING",
    "transactionRegion": "UK"
  }
}
```
```json with ACH/ECP
{
  "vaultedShopperId": 22330225,
  "transactionId": "1015609477",
  "transactionDate": "2018-01-25",
  "amount": 65,
  "currency": "USD",
  "softDescriptor": "BLS*Testing",
  "paymentSource": {
    "ecpInfo": {
      "ecp": {
        "accountNumber": "4099999992",
        "routingNumber": "011075150",
        "accountType": "CONSUMER_CHECKING"
      }
    }
  },
  "chargeInfo": {
    "chargeType": "INITIAL"
  },
  "processingInfo": {
    "processingStatus": "PENDING",
    "cvvResponseCode": "MA",
    "authorizationCode": "OK1510",
    "avsResponseCodeZip": "U",
    "avsResponseCodeAddress": "U",
    "avsResponseCodeName": "U",
    "networkTransactionId": 16029749259621,
    "transactionRegion": "US"
  }
}
```
```json with Google Pay Tokenized CC
{
    "subscriptionId": 39555006,
    "vaultedShopperId": 19639434,
    "transactionId": "38593756",
    "transactionDate": "2018-11-12",
    "amount": 45,
    "currency": "USD",
    "softDescriptor": "BLS*Testing",
    "paymentSource": {
        "wallet": {
            "walletType": "GOOGLE_PAY",
            "billingContactInfo": {
                "firstName": "Susan",
                "lastName": "madden",
                "address1": "351 Eliot Street",
                "city": "Milton",
                "state": "MA",
                "zip": "02186",
                "country": "us"
            },
            "tokenizedCard": {
                "cardLastFourDigits": "7971",
                "cardType": "VISA",
                "cardSubType": "CREDIT",
                "dpanExpirationMonth": "9",
                "dpanExpirationYear": "2025",
                "dpanLastFourDigits": "2041"
            }
        }
    },
    "chargeInfo": {
        "chargeType": "INITIAL"
    },
    "processingInfo": {
        "processingStatus": "SUCCESS",
        "cvvResponseCode": "MA",
        "authorizationCode": "OK1510",
        "avsResponseCodeZip": "U",
        "avsResponseCodeAddress": "U",
        "avsResponseCodeName": "U",
        "networkTransactionId": 16029749259621,
        "transactionRegion": "US"
    }
}
```
```json with Google Pay Non-tokenized CC
{
    "subscriptionId": 39555006,
    "vaultedShopperId": 19639432,
    "transactionId": "38593754",
    "transactionDate": "2018-11-12",
    "amount": 45,
    "currency": "USD",
    "softDescriptor": "BLS*Testing",
    "paymentSource": {
        "creditCardInfo": {
            "creditCard": {
                "cardLastFourDigits": "1111",
                "cardType": "VISA",
                "binCategory": "CONSUMER",
                "expirationMonth": "12",
                "expirationYear": "2023"
            }
        }
    },
    "chargeInfo": {
        "chargeType": "INITIAL"
    },
    "processingInfo": {
        "processingStatus": "SUCCESS",
        "cvvResponseCode": "MA",
        "authorizationCode": "OK1510",
        "avsResponseCodeZip": "U",
        "avsResponseCodeAddress": "U",
        "avsResponseCodeName": "U",
        "networkTransactionId": 16029749259621,
        "transactionRegion": "US"
    }
}
```
```json New shopper with different billing
{ 
   "chargeId":251307,
   "subscriptionId":39598858,
   "vaultedShopperId":19641864,
   "transactionId":"38597362",
   "transactionDate":"2019-01-27",
   "amount":10.00,
   "currency":"USD",
   "softDescriptor":"BLS*Testing",
   "paymentSource":{  
      "creditCardInfo":{  
         "billingContactInfo":{  
            "firstName":"BiFirstName",
            "lastName":"BiLastName",
            "address1":"BiAddress1",
            "address2":"BiAddress2",
            "city":"BiCity",
            "state":"CA",
            "zip":"BiZip",
            "country":"us"
         },
         "creditCard":{  
            "cardLastFourDigits":"4444",
            "cardType":"MASTERCARD",
            "binCategory":"CONSUMER",
            "expirationMonth":"07",
            "expirationYear":"2025"
         }
      }
   },
   "chargeInfo":{  
      "chargeType":"INITIAL"
   },
   "processingInfo":{  
      "processingStatus": "SUCCESS",
      "cvvResponseCode": "MA",
      "authorizationCode": "OK1510",
      "avsResponseCodeZip": "U",
      "avsResponseCodeAddress": "U",
      "avsResponseCodeName": "U",
      "networkTransactionId": 16029749259621,
      "transactionRegion": "US"
   },
   "fraudResultInfo":{  
      "deviceDataCollector":"N"
   }
}
```
```json Vaulted shopper with billing
{
   "chargeId":251323,
   "subscriptionId":39598874,
   "vaultedShopperId":19641880,
   "transactionId":"38597386",
   "transactionDate":"2019-01-27",
   "amount":10.00,
   "currency":"USD",
   "softDescriptor":"BLS*Testing",
   "paymentSource":{  
      "creditCardInfo":{  
         "billingContactInfo":{  
            "firstName":"BiFirstName",
            "lastName":"BiLastName",
            "address1":"BiAddress1",
            "address2":"BiAddress2",
            "city":"BiCity",
            "state":"CA",
            "zip":"BiZip",
            "country":"us"
         },
         "creditCard":{  
            "cardLastFourDigits":"4444",
            "cardType":"MASTERCARD",
            "binCategory":"CONSUMER",
            "expirationMonth":"07",
            "expirationYear":"2025"
         }
      }
   },
   "chargeInfo":{  
      "chargeType":"INITIAL"
   },
   "processingInfo":{  
      "processingStatus": "SUCCESS",
      "cvvResponseCode": "MA",
      "authorizationCode": "OK1510",
      "avsResponseCodeZip": "U",
      "avsResponseCodeAddress": "U",
      "avsResponseCodeName": "U",
      "networkTransactionId": 16029749259621,
      "transactionRegion": "US"
   },
   "fraudResultInfo":{  
      "deviceDataCollector":"N"
   }
}
```
```json New shopper with hosted fields and different billing
{
   "chargeId":251317,
   "subscriptionId":39598868,
   "vaultedShopperId":19641874,
   "transactionId":"38597376",
   "transactionDate":"2019-01-27",
   "amount":10.00,
   "currency":"USD",
   "softDescriptor":"BLS*Testing",
   "paymentSource":{  
      "creditCardInfo":{  
         "billingContactInfo":{  
            "firstName":"BiFirstName",
            "lastName":"BiLastName",
            "address1":"BiAddress1",
            "address2":"BiAddress2",
            "city":"BiCity",
            "state":"CA",
            "zip":"BiZip",
            "country":"us"
         },
         "creditCard":{  
            "cardLastFourDigits":"0005",
            "cardType":"AMEX",
            "binCategory":"CONSUMER",
            "expirationMonth":"11",
            "expirationYear":"2024"
         }
      }
   },
   "chargeInfo":{  
      "chargeType":"INITIAL"
   },
   "processingInfo":{  
      "processingStatus": "SUCCESS",
      "cvvResponseCode": "MA",
      "authorizationCode": "OK1510",
      "avsResponseCodeZip": "U",
      "avsResponseCodeAddress": "U",
      "avsResponseCodeName": "U",
      "networkTransactionId": 16029749259621,
      "transactionRegion": "US"
   },
   "fraudResultInfo":{  
      "deviceDataCollector":"N"
   }
}
```
```json Vaulted shopper with hosted fields and different billing
{  
   "chargeId":251311,
   "subscriptionId":39598862,
   "vaultedShopperId":19641868,
   "transactionId":"38597370",
   "transactionDate":"2019-01-27",
   "amount":10.00,
   "currency":"USD",
   "softDescriptor":"BLS*Testing",
   "paymentSource":{  
      "creditCardInfo":{  
         "billingContactInfo":{  
            "firstName":"BiFirstName",
            "lastName":"BiLastName",
            "address1":"BiAddress1",
            "address2":"BiAddress2",
            "city":"BiCity",
            "state":"CA",
            "zip":"BiZip",
            "country":"us"
         },
         "creditCard":{  
            "cardLastFourDigits":"0005",
            "cardType":"AMEX",
            "binCategory":"CONSUMER",
            "expirationMonth":"11",
            "expirationYear":"2024"
         }
      }
   },
   "chargeInfo":{  
      "chargeType":"INITIAL"
   },
   "processingInfo":{  
      "processingStatus": "SUCCESS",
      "cvvResponseCode": "MA",
      "authorizationCode": "OK1510",
      "avsResponseCodeZip": "U",
      "avsResponseCodeAddress": "U",
      "avsResponseCodeName": "U",
      "networkTransactionId": 16029749259621,
      "transactionRegion": "US"
   },
   "fraudResultInfo":{  
      "deviceDataCollector":"N"
   }
}
```
```json with Authorization Code
{
   "chargeId": 14837941,
   "subscriptionId": 13823081,
   "vaultedShopperId": 23976843,
   "transactionId": "1020296963",
   "merchantTransactionId": "MyUniqueOnDemandSubscription",
   "transactionDate": "2019-03-14",
   "amount": 45,
   "currency": "USD",
   "softDescriptor": "BLS*Testing",
   "paymentSource": {
       "creditCardInfo": {
           "billingContactInfo": {
               "firstName": "John",
               "lastName": "Doe",
               "zip": "02453",
               "country": "us"
           },
           "creditCard": {
               "cardLastFourDigits": "0026",
               "cardType": "VISA",
               "cardSubType": "CREDIT",
               "cardCategory": "CLASSIC",
               "binCategory": "CONSUMER",
               "cardRegulated": "N",
               "issuingBank": "EXTRAS TEST - VISA",
               "expirationMonth": "05",
               "expirationYear": "2023",
               "issuingCountryCode": "ru"
           }
       }
   },
   "chargeInfo": {
       "chargeType": "INITIAL"
   },
   "processingInfo": {
       "processingStatus": "SUCCESS",
       "cvvResponseCode": "MA",
       "authorizationCode": "OK1510",
       "avsResponseCodeZip": "U",
       "avsResponseCodeAddress": "U",
       "avsResponseCodeName": "U",
       "networkTransactionId": 16029749259621,
       "transactionRegion": "US"
   },
   "fraudResultInfo": {
       "deviceDataCollector": "N"
   }
}
```
```json with vendors info
{
  "chargeId": 18319053,
  "subscriptionId": 19752665,
  "vaultedShopperId": 27568045,
  "transactionId": "1031082689",
  "merchantTransactionId": "MyUniqueOnDemandSubscription",
  "transactionDate": "2020-05-26",
  "amount": 45.0,
  "currency": "USD",
  "softDescriptor": "BLS*default_descriptor",
  "paymentSource": {
    "creditCardInfo": {
      "billingContactInfo": {
        "firstName": "John",
        "lastName": "Doe",
        "zip": "02453",
        "country": "us"
      },
      "creditCard": {
        "cardLastFourDigits": "0026",
        "cardType": "VISA",
        "cardSubType": "CREDIT",
        "cardCategory": "CLASSIC",
        "binCategory": "CONSUMER",
        "cardRegulated": "N",
        "issuingBank": "EXTRAS TEST - VISA",
        "expirationMonth": "05",
        "expirationYear": "2023",
        "issuingCountryCode": "ru"
      }
    }
  },
  "chargeInfo": {
    "chargeType": "INITIAL"
  },
  "processingInfo": {
    "processingStatus": "SUCCESS",
    "cvvResponseCode": "MA",
    "authorizationCode": "OK1510",
    "avsResponseCodeZip": "U",
    "avsResponseCodeAddress": "U",
    "avsResponseCodeName": "U",
    "networkTransactionId": 16029749259621,
    "transactionRegion": "US"
  },
  "vendorsInfo": {
    "vendorInfo": [
      {
        "vendorId": 10398032,
        "commissionPercent": 90.2
      }
    ]
  },
  "fraudResultInfo": {}
}
```
```json with metadata
{
  "chargeId": 20400685,
  "subscriptionId": 23451699,
  "vaultedShopperId": 29970021,
  "transactionId": "1039090759",
  "merchantTransactionId": "112222",
  "transactionDate": "2020-12-28",
  "amount": 100,
  "currency": "USD",
  "softDescriptor": "BLS*default_descriptor",
  "paymentSource": {
    "creditCardInfo": {
      "billingContactInfo": {
        "firstName": "John",
        "lastName": "Doe",
        "zip": "92614",
        "country": "us"
      },
      "creditCard": {
        "cardLastFourDigits": "1111",
        "cardType": "VISA",
        "cardSubType": "CREDIT",
        "binCategory": "CONSUMER",
        "cardRegulated": "Y",
        "issuingBank": "JPMORGAN CHASE BANK, N.A.",
        "expirationMonth": "05",
        "expirationYear": "2023",
        "issuingCountryCode": "us"
      }
    }
  },
  "chargeInfo": {
    "chargeType": "INITIAL"
  },
  "processingInfo": {
    "processingStatus": "SUCCESS",
    "cvvResponseCode": "MA",
    "authorizationCode": "OK1510",
    "avsResponseCodeZip": "U",
    "avsResponseCodeAddress": "U",
    "avsResponseCodeName": "U",
    "networkTransactionId": 16029749259621,
    "transactionRegion": "US"
  },
  "fraudResultInfo": {}
}
```

# API Explorer

BlueSnap provides a sandbox environment so you can test basic requests with this endpoint. You can view the request in the API Explorer console and its response directly below the console.

The console includes a sample request with predefined parameter values. To send a request with custom values, edit the parameter fields below. As you edit the fields, your custom values display in the request in the console.

Click the **Try it!** button below the request example when you are ready to send your request.

# OpenAPI definition

```json
{
  "openapi": "3.1.0",
  "info": {
    "title": "json",
    "version": "8976-JSON"
  },
  "servers": [
    {
      "url": "https://sandbox.bluesnap.com/services/2"
    }
  ],
  "components": {
    "securitySchemes": {
      "sec0": {
        "type": "apiKey",
        "in": "header",
        "name": "Authorization",
        "x-bearer-format": "basic",
        "x-default": "QVBJXzE2MTk2MjgyMzU0ODkyMDM5MTMzODc0OkFsdG9pZHMxIQ=="
      }
    }
  },
  "security": [
    {
      "sec0": []
    }
  ],
  "paths": {
    "/recurring/ondemand": {
      "post": {
        "summary": "Create Merchant-Managed Subscription",
        "description": "",
        "operationId": "create-merchant-managed-subscription",
        "requestBody": {
          "content": {
            "application/json": {
              "schema": {
                "type": "object",
                "properties": {
                  "amount": {
                    "type": "number",
                    "default": 45,
                    "format": "float"
                  },
                  "currency": {
                    "type": "string",
                    "default": "USD"
                  },
                  "payerInfo": {
                    "type": "object",
                    "properties": {
                      "firstName": {
                        "type": "string",
                        "default": "John"
                      },
                      "lastName": {
                        "type": "string",
                        "default": "Doe"
                      },
                      "zip": {
                        "type": "string",
                        "default": "02453"
                      },
                      "country": {
                        "type": "string",
                        "default": "us"
                      }
                    }
                  },
                  "paymentSource": {
                    "type": "object",
                    "properties": {
                      "creditCardInfo": {
                        "type": "object",
                        "properties": {
                          "creditCard": {
                            "type": "object",
                            "properties": {
                              "expirationYear": {
                                "type": "integer",
                                "default": 2026,
                                "format": "int32"
                              },
                              "securityCode": {
                                "type": "string",
                                "default": "111"
                              },
                              "expirationMonth": {
                                "type": "integer",
                                "default": 5,
                                "format": "int32"
                              },
                              "cardNumber": {
                                "type": "string",
                                "default": "4012000033330026"
                              }
                            }
                          }
                        }
                      }
                    }
                  }
                }
              }
            }
          }
        }
      }
    }
  },
  "x-readme": {
    "headers": [
      {
        "key": "content-type",
        "value": "application/json"
      },
      {
        "key": "accept",
        "value": "application/json"
      },
      {
        "key": "bluesnap-version",
        "value": "3.0"
      }
    ],
    "explorer-enabled": true,
    "proxy-enabled": true
  },
  "x-readme-fauxas": true
}
```